//ESP32 based GPS receiver - new
#include <Adafruit_GFX.h>
#include <TFT_ILI9163C.h>

#define RXD2 16    //1 serial1=1,3  (green-TX-P16)
#define TXD2 17    //3 serial2=16,17 (yellow-RX-P17)

String val,val2;
char* val1;
String list[250];
char times[8];
int caldow=0;
/*
 DS3231
------
Vcc = 3.3 Volt
Gnd = Gnd
SDA = D23
SCK = D18
*/

int i,j=0,len=0,k=0;
const int timezonehh = 5; //Timezone hour offset
const int timezonemm = 30; //Timezone minute offset


/*
$GNRMC,161007.00,A,2405.32620,N,08238.88648,E,0.433,,300619,,,A*6B
$GNVTG,,T,,M,0.433,N,0.802,K,A*33
$GNGGA,161007.00,2405.32620,N,08238.88648,E,1,08,0.97,280.8,M,-53.1,M,,*60
$GNGSA,A,3,21,32,20,14,24,27,31,08,,,,,1.83,0.97,1.55*15
$GNGSA,A,3,,,,,,,,,,,,,1.83,0.97,1.55*19
$GPGSV,4,1,16,08,09,293,17,10,54,012,07,12,02,091,,14,48,267,19*7B
$GPGSV,4,2,16,18,06,322,23,20,53,064,20,21,45,161,11,24,20,044,27*74
$GPGSV,4,3,16,25,08,127,,27,20,259,21,31,26,193,24,32,59,298,29*76
$GPGSV,4,4,16,36,27,252,,40,48,232,,41,62,179,,49,03,265,*71
$GLGSV,3,1,09,67,36,332,,68,08,284,,76,28,062,,77,35,129,*63
$GLGSV,3,2,09,78,07,174,,81,39,210,,82,46,285,,83,13,328,*60
$GLGSV,3,3,09,88,05,177,*58
$GNGLL,2405.32620,N,08238.88648,E,161007.00,A,A*7B
*/

// Color definitions
#define BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0  
#define WHITE   0xFFFF

TFT_ILI9163C display = TFT_ILI9163C(4,15,2);  //(CS,A0,RST);

uint16_t ccenterx,ccentery;//center x,y of the clock
const uint16_t cradius = 63;//radius of the clock
const float scosConst = 0.0174532925;
float sx = 0, sy = 1, mx = 1, my = 0, hx = -1, hy = 0;
float sdeg=0, mdeg=0, hdeg=0;
uint16_t osx,osy,omx,omy,ohx,ohy;
uint16_t x0 = 0, x1 = 0, yy0 = 0, yy1 = 0;
uint32_t targetTime = 0;// for next 1 second timeout
uint8_t hh,mm,ss;  //containers for current time
uint8_t dd,mn,yy;
char datadate[16];

String dow[7]  = {"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};  // Sunday is dayOfWeek 0
String moy[12] = {"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"}; // January is month 0


void setup() {
Serial.begin(115200);
Serial2.begin(9600, SERIAL_8N1, RXD2, TXD2);  //16,17
Serial.println("Serial Txd is on pin: "+String(TXD2));
Serial.println("Serial Rxd is on pin: "+String(RXD2));
//Serial2.println("PMTK_SET_NMEA_OUTPUT_OFF");
//Serial2.println("$PMTK622,1*29");

  display.begin();
display.setRotation(0);  //rotation of screen
//  WiFi.begin(ssid, password);

display.setTextSize(1);
display.setTextColor(WHITE);
display.setCursor(0,0);
display.clearScreen();
 
  ccenterx = display.width()/2;
  ccentery = display.height()/2+10;
  osx = ccenterx;
  osy = ccentery;
  omx = ccenterx;
  omy = ccentery;
  ohx = ccenterx;
  ohy = ccentery;
  drawClockFace();// Draw clock face
}

void loop() {
while (Serial2.available())    {
//       char c = Serial2.read();
       val+=Serial2.readStringUntil('\r\n');//c; 
      }
//val.trim();      
//len=val.length();
//Serial.println(len);
//Serial.println(val);  //may be commented out if loading the MCU
//j=val.lastIndexOf(',');
delay(500);
//Serial.println(j);
//for(i=0;i<=j-1;i++) list[i]= getValue(val,',',i);
for(i=0;i<=200;i++) list[i]= getValue(val,',',i);

if((list[0]=="$GPRMC" or list[0]=="$GNRMC") && (list[2]=="A" or list[2]=="V") ) {  //$GNRMC+A or $GPRMC+V
hh=list[1].substring(0,2).toInt();
mm=list[1].substring(2,4).toInt();
ss=list[1].substring(4,6).toInt();

dd=list[9].substring(0,2).toInt();
mn=list[9].substring(2,4).toInt();
yy=list[9].substring(4,6).toInt();
 
//Serial.println(dow[calcDayOfWeek( dd,mn,yy)]);                // Call routine using DD, MM, YY, it returns the dayoftheweek, where Sun=1, Mon=2, Tue=3, Wed=4, Thu=5, Fri=6, Sat=7

mm = mm + timezonemm;
    if (mm > 59) {
      mm = mm - 60;
      hh = hh + 1;
    }
    else {
      if (mm < 0) {
        mm = mm + 60;
        hh = hh - 1;
      }
    }
    hh = hh + timezonehh;
    if (hh > 23) {
      hh = hh - 24;
      dd=dd+1;
     if(mn==1 && dd>31) mn = mn+1;
     if(mn==2 && dd>28) mn = mn+1;
     if(mn==3 && dd>31) mn = mn+1;
     if(mn==4 && dd>30) mn = mn+1;
     if(mn==5 && dd>31) mn = mn+1;
     if(mn==6 && dd>30) mn = mn+1;
     if(mn==7 && dd>31) mn = mn+1;
     if(mn==8 && dd>31) mn = mn+1;
     if(mn==9 && dd>30) mn = mn+1;
     if(mn==10 && dd>31) mn = mn+1;
     if(mn==11 && dd>30) mn = mn+1;
     if(mn==12 && dd>31) { mn = mn+1; yy=yy+1; }
     }
    else {
      if (hh < 0) {
        hh = hh + 24;
       }
    }
sprintf(times,"%02d:%02d:%02d",hh,mm,ss);
Serial.print(dow[calcDayOfWeek(dd,mn,yy)]);
Serial.print("  Status:");
Serial.print(list[2]);
Serial.print(" ");
Serial.print("Time:");
Serial.print(times);
Serial.print(" ");
Serial.print("Date:");
Serial.print(list[9]);
Serial.print(" ");
Serial.print("Lat:");
Serial.print(list[3]);
Serial.print(list[4]);
int mt=millis();
//Serial.print(" ");
//Serial.print(mt);

Serial.print(" ");
Serial.print("Lon:");
Serial.print(list[5]);
Serial.print(list[6]);

Serial.print(" ");
Serial.print("KPH:");
Serial.print(list[19]);

Serial.print(" S:");
Serial.print(list[28]);

Serial.print(" ");
Serial.print("Alt:");
Serial.print(list[30]);
Serial.println(list[31]);

//TFT Display
display.setTextSize(3);
display.setTextColor(GREEN,BLACK);
display.setCursor(0,0);

printDigits(hh);
display.print(":");
printDigits(mm);
display.setTextSize(2);
display.setTextColor(CYAN,BLACK);
display.setCursor(95,0);
printDigits(ss);
display.println();
display.setTextColor(MAGENTA,BLACK);
display.setCursor(92,15);
display.println(dow[calcDayOfWeek(dd,mn,yy)]);

sprintf(datadate, "%.2d/%.2d/%d", dd,mn,yy);
display.setCursor(display.width()/2-23,display.height()/2-10);
display.setTextSize(0.5); //2
display.setTextColor(0x07FF,BLACK);
display.print(datadate);
drawClockHands(hh,mm,ss);

//mt=0;
}

// ---important resetting required ------
val="";
len=0;
}

String getValue(String data, char separator, int index){
  int found = 0;
  int strIndex[] = {0, -1};
  int maxIndex = data.length()-1;
  for(int i=0; i<=maxIndex && found<=index; i++){
    if(data.charAt(i)==separator || i==maxIndex){
        found++;
        strIndex[0] = strIndex[1]+1;
        strIndex[1] = (i == maxIndex) ? i+1 : i;
    }
  }

  return found>index ? data.substring(strIndex[0], strIndex[1]) : "";
}



void drawClockFace(){
//  cradius = cradius - 20;
  display.fillCircle(ccenterx, ccentery, cradius-10, BLUE);  //blue
  display.fillCircle(ccenterx, ccentery, cradius-4-10, BLACK); //black
  // Draw 12 lines
  for(int i = 0; i<360; i+= 30) {
    sx = cos((i-90)*scosConst);
    sy = sin((i-90)*scosConst);
    x0 = sx*(cradius-4-10)+ccenterx;
    yy0 = sy*(cradius-4-10)+ccentery;
    x1 = sx*(cradius-11-10)+ccenterx;
    yy1 = sy*(cradius-11-10)+ccentery;
    display.drawLine(x0, yy0, x1, yy1, CYAN);  //blue
  }
}

static uint8_t conv2d(const char* p) {
  uint8_t v = 0;
  if ('0' <= *p && *p <= '9') v = *p - '0';
  return 10 * v + *++p - '0';
}


void drawClockHands(uint8_t h,uint8_t m,uint8_t s){
  // Pre-compute hand degrees, x & y coords for a fast screen update
  sdeg = s * 6;                  // 0-59 -> 0-354
  mdeg = m * 6 + sdeg * 0.01666667;  // 0-59 -> 0-360 - includes seconds
  hdeg = h * 30 + mdeg * 0.0833333;  // 0-11 -> 0-360 - includes minutes and seconds
  hx = cos((hdeg-90)*scosConst);    
  hy = sin((hdeg-90)*scosConst);
  mx = cos((mdeg-90)*scosConst);    
  my = sin((mdeg-90)*scosConst);
  sx = cos((sdeg-90)*scosConst);    
  sy = sin((sdeg-90)*scosConst);

  // Erase just old hand positions
  display.drawLine(ohx, ohy, ccenterx+1, ccentery+1, BLACK);  
  display.drawLine(omx, omy, ccenterx+1, ccentery+1, BLACK);  
  display.drawLine(osx, osy, ccenterx+1, ccentery+1, BLACK);
  // Draw new hand positions  
  display.drawLine(hx*(cradius-28)+ccenterx+1, hy*(cradius-28)+ccentery+1, ccenterx+1, ccentery+1, GREEN);  //white
  display.drawLine(mx*(cradius-17)+ccenterx+1, my*(cradius-17)+ccentery+1, ccenterx+1, ccentery+1, WHITE);
  display.drawLine(sx*(cradius-14)+ccenterx+1, sy*(cradius-14)+ccentery+1, ccenterx+1, ccentery+1, RED);
  display.fillCircle(ccenterx+1, ccentery+1, 3, RED);

  // Update old x&y coords
  osx = sx*(cradius-14)+ccenterx+1;
  osy = sy*(cradius-14)+ccentery+1;
  omx = mx*(cradius-17)+ccenterx+1;
  omy = my*(cradius-17)+ccentery+1;
  ohx = hx*(cradius-28)+ccenterx+1;
  ohy = hy*(cradius-28)+ccentery+1;
}

void printDigits(int digits){
  if(digits < 10)
    display.print('0');
  display.print(digits);
}

byte   calcDayOfWeek(int d, int m, int y)  {       // https://en.wikipedia.org/wiki/Determination_of_the_day_of_the_week
        static int t[] = {0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4};
        y -= m < 3;
        return (y + y/4 - y/100 + y/400 + t[m-1] + d) % 7;    // Sun=0, Mon=1, Tue=2, Wed=3, Thu=4, Fri=5, Sat=6
    }
